use axum::{routing::{get, post, MethodRouter}, Router};
use library::typed_router::TypedRouter;

pub mod account_controller;
pub mod feedback_controller;

pub fn init() -> Router {
    // let a = feedback_controller::get_feedback_list;
    
    // axum::routing::method_routing::MethodRouter::new()

    
    let router = Router::new()
        .route(
            "/account/google",
            post(account_controller::authenticate_google),
        )
        .route(
            "/account/sys",
            post(account_controller::authenticate_with_password),
        )
        .route(
            "/account/refresh-token", 
            post(account_controller::refresh_token)
        )
        .route(
            "/feedback",
            post(feedback_controller::add_feedback)
                .get(feedback_controller::get_feedback_list_by_page)
        )
        .typed_route(route)
        // .typed_route(feedback_controller::get_feedback_list)
        // .merge(feedback_controller::get_feedback_list::route())
        // .typed_route(route)
        // .route(
        //     "/feedback/:page/:pageSize",
        //     get(feedback_controller::get_feedback_list)
        // )
        ;
        return router;
}

fn route() -> (&'static str, MethodRouter) {
    pub async fn route() -> String {
        return "hello world".to_string();
    }
    ("/feedback1", axum::routing::get(route))
}